# -*- coding: utf-8 -*-

import os, sys

import xbmc, xbmcplugin, xbmcgui

from xbmcup.app import Link, Handler, Plugin, _setting
import bazaknig
from history import History, HistoryAdd

_view_ = _setting['view']

plugin = Plugin()


def normname(s):
	if ' (' in s: s = s[:s.find(' (')]
	return s


@plugin.radd()
class Menu(Handler):
	def handle(self):
		self.item(Link('catalog',{'search': True}), title='[Поиск]')
		self.item(Link('history'), title='[История поиска]')
		self.item(Link(Filters), title='Умный поиск')
		self.item(Link(Catalog), title='Каталог книг')
		#self.item(Link(Authors), title='Авторы')
		#self.item(Link(Readers), title='Исполнители')
		self.item(Link(Genres), title='Жанры')
		self.item(Link(TopWeek), title='Топ книг за неделю')
		self.render(nextmode=_view_)

@plugin.radd()
class TopWeek(Handler):
	def handle(self):
		d = bazaknig.topweek()
		for i in d['topweek']:
			title = i['info']['title']
			self.popupadd(Link(BookInfo, {'info': i['info']}), 'Информация о книге', True, True)
			self.popupadd(Link('catalog', {'search': True, 'textsearch': title}, True), 'Поиск')
			self.item(Link('video',{'url': i['url']}), title=title, thumb=i['thumb'], info=i['info'], popup=True, popup_replace=True)
		self.render(nextmode=_view_)

@plugin.radd()
class Filters(Handler):
	def handle(self):
		nazvanie = self.argv.get('nazvanie')
		cikl = self.argv.get('cikl')
		ispolnitel = self.argv.get('ispolnitel')
		autor = self.argv.get('autor')

		sort_i = self.argv.get('sort_i', 0)
		order_i = self.argv.get('order_i', 0)
		d = self.argv.get('d')
		if d is None:
			d = bazaknig.filter()
			replace = False
		else: replace = True

		if nazvanie == True:
			nazvanie = self.kbdinput('Введите название книги:')
			if nazvanie is None: return True
		elif cikl == True:
			cikl = self.kbdinput('Введите название цикла:')
			if cikl is None: return True
		elif ispolnitel == True:
			ispolnitel = self.kbdinput('Введите фамилию чтеца:')
			if ispolnitel is None: return True
		elif autor == True:
			autor = self.kbdinput('Введите фамилию автора:')
			if autor is None: return True
		elif isinstance(sort_i, bool):
			index = xbmcgui.Dialog().select(self.nameaddon, [ x[1] for x in d['sort'] ])
			if index < 0:
				return True
			else:
				sort_i = index
		elif isinstance(order_i, bool):
			index = xbmcgui.Dialog().select(self.nameaddon, [ x[1] for x in d['order'] ])
			if index < 0:
				return True
			else:
				order_i = index
		n_nazv = nazvanie if nazvanie else 'Введите название книги'
		n_cikl = cikl if cikl else 'Введите название цикла'
		n_ispo = ispolnitel if ispolnitel else 'Введите фамилию чтеца'
		n_auto = autor if autor else 'Введите фамилию автора'
		self.item(Link(Filters,{'d':d, 'nazvanie': True, 'cikl': cikl, 'ispolnitel': ispolnitel, 'autor': autor, 'sort_i': sort_i, 'order_i': order_i}) , title=n_nazv)
		self.item(Link(Filters,{'d':d, 'nazvanie': nazvanie, 'cikl': True, 'ispolnitel': ispolnitel, 'autor': autor, 'sort_i': sort_i, 'order_i': order_i}) , title=n_cikl)
		self.item(Link(Filters,{'d':d, 'nazvanie': nazvanie, 'cikl': cikl, 'ispolnitel': True, 'autor': autor, 'sort_i': sort_i, 'order_i': order_i}) , title=n_ispo)
		self.item(Link(Filters,{'d':d, 'nazvanie': nazvanie, 'cikl': cikl, 'ispolnitel': ispolnitel, 'autor': True, 'sort_i': sort_i, 'order_i': order_i}) , title=n_auto)
		self.item(Link(Filters,{'d':d, 'nazvanie': nazvanie, 'cikl': cikl, 'ispolnitel': ispolnitel, 'autor': autor, 'sort_i': True, 'order_i': order_i}), title=d['sort'][sort_i][1])
		self.item(Link(Filters,{'d':d, 'nazvanie': nazvanie, 'cikl': cikl, 'ispolnitel': ispolnitel, 'autor': autor, 'sort_i': sort_i, 'order_i': True}), title=d['order'][order_i][1])
		f = {}
		def _enc(s):
			if isinstance(s, unicode): s = s.encode('utf8')
			return s
		if isinstance(nazvanie, basestring) and _enc(nazvanie) != '': f['nazvanie'] = _enc(nazvanie)
		if isinstance(cikl, basestring) and _enc(cikl) != '': f['cikl'] = _enc(cikl)
		if isinstance(ispolnitel, basestring) and _enc(ispolnitel) != '': f['t-x.ispolnitel;x.ispolnitel2;x.ispolnitel3'] = _enc(ispolnitel)
		if isinstance(autor, basestring) and _enc(autor) != '': f['autor'] = _enc(autor)
		f['order_by'] = d['sort'][sort_i][0]
		if order_i > 0: f['order'] = d['order'][order_i][0]
		from urllib import urlencode
		furl = urlencode(f).replace('&','/')
		url = '/f/'+furl
		self.item(Link(Catalog,{'url':url, 's_kbd': True}), title='Найти книги')
		self.item(Link(Filters,{'d':d}), title='Очистить список')
		self.render(nextmode=_view_, replace=replace)

@plugin.radd()
class Authors(Handler):
	def handle(self):
		data = bazaknig.authors()
		for i in data['data']:
			self.item(Link(ARrezult,{'url': i[1]}), title=i[0])
		self.render(nextmode=_view_)

@plugin.radd()
class Readers(Handler):
	def handle(self):
		data = bazaknig.readers()
		for i in data['data']:
			self.item(Link(ARrezult,{'url': i[1]}), title=i[0])
		self.render(nextmode=_view_)

@plugin.radd()
class ARrezult(Handler):
	def handle(self):
		url = self.argv.get('url')
		data = bazaknig.ar_rezult(url)
		for i in data['data']:
			self.item(Link(Catalog,{'url': i[1]}), title=i[0])
		self.render(nextmode=_view_)

@plugin.radd()
class Genres(Handler):
	def handle(self):
		data = bazaknig.genres()
		for i in data['genres']:
			self.item(Link('catalog',{'url': i[1]}), title=i[0])
		self.render(nextmode=_view_)

@plugin.radd()
class Catalog(Handler):
	def handle(self):
		search = self.argv.get('search')
		url = self.argv.get('url')
		s_kbd = self.argv.get('s_kbd', False)
		sort = self.argv.get('sort')
		data = self.argv.get('data', None)
		page = self.argv.get('page')
		if sort:
			index = xbmcgui.Dialog().select(self.nameaddon, [x[0] for x in sort])
			if index < 0:
				return True
			else:
				url = sort[index][1]
		if page and search:
			s1, data = bazaknig.nextsearch(search, page)
		elif search:
			if isinstance(search, bool):
				textsearch = self.argv.get('textsearch', '')
				search = self.kbdinput('Поиск', textsearch)
				if search is None: return True
				s_kbd = True
				HistoryAdd(search)
			s1, data = bazaknig.search(search)
		elif url == 0:
			return True
		elif data is None:
			data = bazaknig.catalog(url)
		if (data['data']==[]) and s_kbd and (data['podbor'] ==[]):
			xbmcgui.Dialog().ok(self.nameaddon, 'Ничего не найдено')
		if data.get('filter'):
			for i in data['filter']:
				self.item(Link('catalog', {'sort': i['sort']}), title=i['name'], media='video', popup=self.popup, popup_replace=True)
		for i in data['data']:
			popup = []
			popup.extend(self.popup)
			title = i['info']['title']
			popup[0] = (Link(BookInfo, {'info': i['info']}), 'Информация о книге')
			popup.insert(1, (Link('catalog', {'search': True, 'textsearch': title}, True), 'Поиск') )
			if i['info'].get('mpaa'): popup.insert(2, (Link(Filters, {'cikl': normname(i['info']['mpaa'])}, True), 'Искать цикл') )
			if i['info'].get('writer'): popup.insert(-1, (Link(Catalog, {'search': i['info']['writer']}, True), 'Еще книги этого автора') )
			if i['info'].get('plotoutline'):
				title = title + u' (' + i['yq'] + u', ' + i['info']['plotoutline'] + u')'
			elif i.get('yq'):
				title = title + u' (' + i['yq'] + u')'
			if i['info'].get('rating'):
				title = title + u' [' + unicode(i['info']['rating']) + u']'
			self.item(Link('video', {'url': i['url']}), title=title, media='music', info=i['info'], thumb=i['thumb'], popup=popup, popup_replace=True)
		for i in data['podbor']:
			self.item(Link('catalog', {'url': i['url']}), title=i['info']['title'], media='music', info=i['info'], thumb=i['thumb'], popup=self.popup, popup_replace=True)
		if data['page']['next']:
			titlepage = 'Следующая страница '+ str(data['page']['current']+1)+ ' из ' + str(data['page']['max']) + ' >>'
			if data['page']['next'] == '#':
				self.item(Link('catalog',{'page':data['page']['snext'], 'search': search}), title=titlepage)
			else:
				self.item(Link('catalog',{'url':data['page']['next']}), title=titlepage)
		self.render(nextmode=_view_)


@plugin.radd()
class Video(Handler):
	def handle(self):
		url = self.argv.get('url')
		if url == 0:
			return True
		d = bazaknig.videoinfo(url)
		data = d['data'][0]
		title = data['info']['title']
		info = data['info']
		self.popupadd(Link(BookInfo, {'info': info}), 'Информация о книге', start=True)
		if d.get('torrent'): self.popupadd(Link(Torrent, {'url': d['torrent'], 'thumb':data['thumb']}, True), 'Открыть торрент')
		if data.get('screenshot'): self.popupadd(Link('screenshot', data['screenshot']), 'Скриншоты' + ' (' + str(len(data['screenshot'])) + ')')
		if d.get('comments'): self.popupadd(Link(Comments, d['comments']), 'Комментарии' + ' (' + str(len(d['comments'])) + ')')
		self.popupadd(Link('catalog', {'search': True, 'textsearch': title}, True), 'Поиск')
		if info.get('mpaa'): self.popupadd(Link(Filters, {'cikl': normname(info['mpaa'])}, True), 'Искать цикл')
		if info.get('writer'):
			if ',' in info['writer']:
				for i in normname(info['writer']).split(','):
					self.popupadd(Link(Catalog, {'search': i.strip()}, True), u'Еще книги ' + i.strip())
				self.popupadd(Link(Catalog, {'search': normname(info['writer'])}, True), 'Еще книги этих авторов')
			else:
				self.popupadd(Link(Catalog, {'search': normname(info['writer'])}, True), 'Еще книги этого автора')
		if isinstance(d['url'], basestring):
			self.item(Link('play',{'url': data['url']}), title=title, media='music', info=info, thumb=data['thumb'], popup=True, popup_replace=True, property=[('IsPlayable','true')], cast=data['cast'], folder=False)
		else:
			self.item(Link('video', {'url': data['url'] }), title=title, media='music', info=data['info'], thumb=data['thumb'], popup=True, popup_replace=True, cast=data['cast'])
			if d['url'] is not None:
				for i in d['url']:
					info['title'] = title + u' / ' + i['title']
					info['tracknumber'] = i['index'] + 1
					self.item(Link('play',{'url': data['url'], 'index': i['index'] }), title=i['title'], media='music', info=info, thumb=data['thumb'], popup=True, popup_replace=True, property=[('IsPlayable','true')], cast=data['cast'], folder=False)
			else:
				self.item(Link('video', {'url': data['url'] }), title='[COLOR yellow]Нет ссылок на аудио.[/COLOR]', media='music', info=info, thumb=data['thumb'], popup=True, popup_replace=True, cast=data['cast'])
				if d.get('pr'): self.item(Link('video', {'url': data['url'] }), title=u'[COLOR pink]'+d['pr']['title']+u'[/COLOR]', media='music', thumb=d['pr']['thumb'], info=info, popup=True, popup_replace=True)
		for i in d['podbor2']:
			self.popupadd(Link(BookInfo, {'info': i['info']}), 'Информация о книге', True, start=True)
			self.item(Link('video', {'url': i['url']}), title=i['info']['title'], media='music', info=i['info'], thumb=i['thumb'], popup=True, popup_replace=True)
		self.render(nextmode=_view_)

@plugin.radd()
class Play(Handler):
	def handle(self):
		url = self.argv.get('url')
		durl = self.argv.get('durl')
		index = self.argv.get('index')
		if url:
			link, error = bazaknig.play_link(url, index)
		elif durl: link = durl
		if link == '': error = ['Нет ссылки на аудио.']
		if link:
			#xbmc.Player().play(link)
			item = xbmcgui.ListItem(path=link)
			xbmcplugin.setResolvedUrl(int(sys.argv[1]),True, item)
		else:
			xbmcgui.Dialog().ok(self.nameaddon, *error)


@plugin.radd()
class Torrent(Handler):
	def handle(self):
		if 'index' in self.argv:
			data = file(xbmc.translatePath('special://temp/baza_knig.torrent').decode('utf8'), 'rb').read()
			from xbmcup import torrserver
			torrserver.play(index=self.argv['index'], data=data)
			return True
		else:
			data, filelist = bazaknig.get_torrent(self.argv['url'])
			file(xbmc.translatePath('special://temp/baza_knig.torrent').decode('utf8'), 'wb').write(data)
			for i in filelist:
				self.argv['index'] = i['id']
				self.item(Link(Torrent, self.argv), title=i['name'], media='music', info={'title': i['name'], 'size': i['size']}, thumb=self.argv['thumb'], playable=True, popup=True)
			self.render(nextmode=_view_)

@plugin.radd()
class ScreenShot(Handler):
	def handle(self):
		from xbmcup import slideshow
		slideshow.open(self.argv, 0)
		return True

@plugin.radd()
class BookInfo(Handler):
	def handle(self):
		info = self.argv.get('info')
		text = u''
		if 'writer' in info:	text += u'Автор книги: ' + info['writer'] + u'\n'
		if 'director' in info:	text += u'Читает: ' + info['director'] + u'\n'
		if 'genre' in info:	text += u'Жанр: ' + info['genre'] + u'\n'
		if 'mpaa' in info:	text += u'Цикл: ' + info['mpaa'] + u'\n'
		if 'year' in info:	text += u'Год выпуска: ' + unicode(info['year']) + u'\n'
		if 'tagline' in info:	text += u'Длительность книги: ' + info['tagline'] + u'\n'
		if 'plotoutline' in info: text += u'Качество: ' + info['plotoutline'] + u'\n'
		if 'studio' in info:	text += u'Добавлено: ' + info['studio'] + u'\n'
		if 'plot' in info:	text += u'Описание: ' + info['plot'] + u'\n'
		gui = GuiTextViewer('DialogTextViewer.xml', sys.argv[0], descript=text, title=info['title'])
		gui.doModal()
		del gui
		return True

@plugin.radd()
class Comments(Handler):
	def handle(self):
		d = self.argv
		text = u''
		for a, c in d:
			text += a + u'\n' + c + u'\n\n'
		gui = GuiTextViewer('DialogTextViewer.xml', sys.argv[0], descript=text, title='Комментарии к книге')
		gui.doModal()
		del gui
		return True

class GuiTextViewer(xbmcgui.WindowXMLDialog):
    def __init__(self, *args, **kwargs):
        self.descript = kwargs['descript']
        self.title = kwargs['title']
        xbmcgui.WindowXMLDialog.__init__(self, *args, **kwargs)
    
    def onInit(self):
        #lang = Lang()
        self.getControl(1).setLabel(self.title)
        self.getControl(5).setText(self.descript)
    
    def onFocus(self, control):
        pass


def main():
	plugin.route('history', History)
	plugin.run(setcontent='songs')


if __name__ == '__main__':
	try:
                search_vars = sys.argv[2].split('?')
                search_vars = search_vars[-1].split('&')
                if 'usearch=True' in search_vars:
                        from urlparse import parse_qs
                        params = parse_qs(sys.argv[2].replace('?', ''))
                        united_search = {'route': 'catalog', 'argv': { 'search': params['keyword'][0] } }
			from urllib import quote_plus
                        import json
                        sys.argv[2] = '?'+quote_plus(json.dumps(united_search))
	except BaseException as e:
		from xbmcup.errors import log
		log(e)

	main()
